/*
 *    AulaChat - Advanced teacher/pupil communication system
 *    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *    
 *    Modulo: Lectura/Escritura de configuracin y recojida de variables
 *            del fichero de configuracin XML.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "config.h"

int config(sconfig *config)
{
   return leeconf(config);   
}

int leeconf(sconfig *conf)
{
   // Retornar 1 si hay cualquier error al leer el fichero.
   // Retornar 0 si ha leido con xito las variables del fichero XML.
   FILE *confile;
   char *buffer;//almacena todo el fichero en la memoria asignada al puntero.
   long confsize;
   if(!(confile=fopen(CONFNAME,"rb"))) return 1;
   else 
     {
	fseek (confile, 0L, SEEK_END);
	confsize = ftell (confile);
	rewind (confile);
	buffer = (char*) calloc (1,confsize*sizeof(char));//mejor calloc que malloc
	if (buffer == NULL) return 1;
	fread(buffer,1,confsize,confile);
     }
   fclose(confile);
   return busconf(buffer, conf);
}

int busconf(char *buffer, sconfig *conf)
{
   int i=0,j=0;
   char *que[]={"<admin_reset_password>","<admin_only>","<port>","<debug>","<user>","<password>","<host>","<sqlport>","<rehacertablas>"};
   char buf2[9][60]={"\0"};
   while(i<9 && !(j+=busconfstr(buffer,que[i],buf2[i])))i++;//se recojen las variables del fichero de conf.
   //a continuacin se inicializa la struct con esos datos.
   strcpy(conf->admin_rp,buf2[0]);
   conf->admin_only=(bit)atoi(buf2[1]);
   conf->port=(int)atoi(buf2[2]);
   conf->debug=(bit)atoi(buf2[3]);
   strcpy(conf->sql_user,buf2[4]);
   strcpy(conf->sql_pass,buf2[5]);
   strcpy(conf->sql_host,buf2[6]);
   conf->sql_port=(int)atoi(buf2[7]);
   conf->retablas=(bit)atoi(buf2[8]);
   return j;//error al no encontrar opcin si j>0, de hecho da el numero de claves fallidas (no encontradas).
}

int busconfstr(char *buffer,char *que, char *buf2)
{   
   char *tmp=NULL;
   char buf[strlen(buffer)];
   int i=0;
   if(!(tmp=strstr(buffer,que)))return 1;
   strcpy(buf,tmp);
   i=(strlen(strtok(buf,"<"))-strlen(que));
   i+=2;
   memcpy(buf2,(buf+strlen(que)),i-1);
   return 0;
}

