/*
 *    AulaChat - Advanced teacher/pupil communication system
 *    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *    
 *    Modulo: Lectura/Escritura de configuracin y recojida de variables
 *            del fichero de configuracin XML.
 */
#ifndef CONFIG_H
#define CONFIG_H

#define CONFNAME "aulachat.xml" //Nombre del fichero de configuracin.

/* Necesario para asignaciones 'booleanas' del tipo true/false,
 * evidentemente en realidad es un byte. */
//TODO: Cambiar ints que funciona como booleanos por 'bit'
typedef unsigned char bit;

// guardamos variables de configuracin en struct.
typedef struct 
{   
   char admin_rp[20];
   bit admin_only; //puede utilizarse posteriormente
   int port;
   // char denied[to_be_updated]; deshabilitado de momento al carecer de importancia.
   bit debug;
   char sql_user[20];
   char sql_pass[30];
   char sql_host[30];
   int sql_port;
   bit retablas;
}sconfig;

/* NOTA:
 * Las funciones van retornando 1 si encuentran algn error.
 * Esto es vlido para todos los mdulos.
 * No obstante pueden retornar NULL u otro valor (incluso 0) si 
 * se produce un error y es necesario retornar otro valor,
 * sobre todo en retorno de punteros.
 */

int leeconf(sconfig *); //Lee el fichero de configuracin
int busconf(char *, sconfig *); //Guarda las variables en su struct correspondiente
int busconfstr(char *,char *, char *); //Busca los datos a almacenar

/* Se hace un retorno de leeconf, por lo tanto parece que podamos
 * prescindir de sta, no obstante se deja as pues posteriormente
 * seguramente se necesite introducir cdigo o llamadas a otras funciones
 * desde aqu.
 */
int config(sconfig *);
#endif
