#!/bin/bash
#
#    AulaChat - Advanced teacher/pupil communication system
#    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#   
#    Modulo: Instalador AulaChat 

VER=0.1Alpha
#se puede poner un if para realizar la instalacin en otro directorio
#diferente al actual. Por defecto se coje este ltimo.
DIR_INST=$PWD

DIR_LIB_SQL=/usr/lib/mysql/
DIR_INC_SQL=/usr/include/mysql/

#tambin se podra hacer un which para localizar todo automticamente.
if [ "$1" = "-lsql" ] && [ "$2" ];
then
 DIR_SQL_BIN=$2
 SQLBIN="$DIR_SQL_BIN""mysql"
else
 SQLBIN=`whereis -b mysql | awk '{print $2}'`
fi
echo "AulaChat $VER - http://www.bluegod.net/aulachat"
echo "Script de instalacin. Por BLuEGoD (James Lpez)."
sleep 1;
clear;
echo "--- Men de instalacin de AulaChat $VER ---"
echo
echo "Este script instalar AulaChat en su sistema."
echo "Si la instalacin no se completa debidamente,"
echo "por favor visite el foro de la web de Aulachat"
echo "WEB: http://www.bluegod.net/aulachat"
echo
echo "A continuacin se le preguntar un par de cuestiones"
echo "relativas a la localizacin de ficheros..."
echo "En cualquier momento puede salir del programa si es necesario,"
echo "para ello solo tiene que presionar CONTROL + C"
echo
echo "Presione cualquier tecla para continuar."
echo
read ;
echo "+ Libreras estandar C"
echo " - Para instalar AulaChat se debe disponer de las libreras estandar"
echo "de C, adems de aquellas IPC como shm.h para la gestin de memoria"
echo "compartida."
echo 
echo "+ Libreras MySQL"
echo " - Para instalar AulaChat se necesita un servidor SQL y las libreras"
echo "del cliente MySQL para C."
echo "Escriba la localizacin de las libreras de MySQL:"
echo "(Normalmente /usr/lib/mysql/ o /usr/local/lib/mysql/)"
echo "[$DIR_LIB_SQL]";
read DIR_LIB_SQL_
echo "Escriba la localizacin de las inclusiones de las librerias de MySQL:"
echo "(Normalmente /usr/lib/mysql/ o /usr/local/include/mysql/)"
echo "[$DIR_INC_SQL]";
read DIR_INC_SQL_

if test $DIR_LIB_SQL_;
 then 
 DIR_LIB_SQL=$DIR_LIB_SQL_
fi

if test $DIR_INC_SQL_;
 then 
 DIR_INC_SQL=$DIR_INC_SQL_
fi

if ! test -d $DIR_LIB_SQL
 then
 echo "ERROR# No existe el directorio $DIR_LIB_SQL";
 exit;
fi

if ! test -d $DIR_LIB_SQL
 then
 echo "ERROR# No existe el directorio $DIR_INC_SQL";
 exit;
fi

echo "+  Configuracin MySQL"
while [ "$bd" != "S" ] &&  [ "$bd" != "s" ] &&  [ "$bd" != "n" ] && [ "$bd" != "N" ]
do 
 echo "Desea instalar la base de datos ahora? (S/N)"
 read bd;
done
if [ "$bd" = "S" ] || [ "$bd" = "s" ]
then
 echo "Se va ejecutar: $SQLBIN -p < ./aula.sql"
 if ! [ -r $SQLBIN ];
  then
  echo "No se puede acceder al fichero $SQLBIN"
  echo "Quiz no tenga instalado MySQL"
  echo "En caso de que lo tenga instalado en otra ubicacin"
  echo "deber ejecutar el script con la opcin -lsql ubicacin"
  echo "Ej: ./instalar.sh -lsql /usr/local/bin/mysql"
  exit;
 fi
 if ! [ -r ./aula.sql ];
  then
  echo "No se puede acceder al fichero aula.sql"
  exit;
 fi
 echo "Escriba el nombre de usuario para conectarse a MySQL:"
 read SQLUSER;
 echo "Se va a proceder a ejecutar $SQLBIN -u $SQLUSER -p < ./aula.sql"
 $SQLBIN -u $SQLUSER -p < ./aula.sql
fi
echo
echo "Se va a proceder a instalar AulaChat $VER"
echo "en el directorio: $DIR_INST"
echo 
echo "Presione cualquier tecla para continuar";
read ;

#Comprobamos 2 cosas.. si existe el fichero y si se puede
#escribir en el _directorio_actual_.

if ! [ -w ./Makefile.in ];
 then
 echo "No se puede acceder al fichero Makefile.in"
 exit;
fi

#Seguro que otras aplicaciones lo hacen de un modo ms optimizado
#pero esto fu lo que se me ocurri a mi :).

echo "#Aadido por el script de instalacin.">Makefile
echo "LIB_SQL1 = $DIR_LIB_SQL" >>Makefile
echo "LIB_SQL2 = $DIR_INC_SQL" >>Makefile
cat Makefile.in >>Makefile

echo 
echo "Finalizado."
echo "1- Ejecute \"make\" para compilar el proyecto."
echo "2- Despues necesitar copiar el fichero aulachat.xml.default a"
echo "aulachat.xml y modificarlo si es necesario."
echo "3- Ejecute el programa escribiendo \"./aulachat\"";

#fin
