/*
 *    AulaChat - Advanced teacher/pupil communication system
 *    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *    
 *    Modulo: Gestin de usuarios.
 *
 */
#ifndef USER_H
#define USER_H

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
//#include <sys/param.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>


#define KN 1 //nmero para la key de la memoria compartida, ha de ser igual para ser comn.
#define KFILE "/bin/ls" // fichero par la key de la memoria compartida.. " " ".
#define POST_VAR_MAX 30 // Nmero mximo de caracteres permitidos en una variable POST al recojer la misma.

key_t clave; //necesario para la memoria compratida.

/* Struct con informacin general (administrador global + profesores)
 * Cada aula est gestionada por un profesor.
 * El aula ADMIN es obligatoriamente la del administrador general,
 * el cual a su vez es el nico que puede crear profesores.
 */

typedef struct aulas
{
   char nombre[15];
   char titulo[50];
   char profe[15];
   char pass[15];
   struct aulas *next;
}aula;

//Struct con la informacin para cada alumno
typedef struct alums
{
   char nombre[15];
   char user[15];
   struct alums *next;
   //la pass no es necesaria; si lo es en aulas por si se necesita resetear.
}alum;

//Struct de almacenamiento de datos
typedef struct almacenes
{
   char nombre[15];
   int id;
   char *texto;
   char remite[15];
   struct almacenes *next;
}almacen;

//Struct de almacenamiento de datos
typedef struct arcas
{
   int id;
   int id2;
   char nombre[15];
   char *texto;
   struct arcas *next;
}arca;

/* Habilita la memoria compartida, adems la genera o la pone a
 * disposicin segn el segundo argumento (lee)
 * Lee = 1 => Slo lee / accede al espacio de memoria compartida
 * Lee = 0 => Genera el espacio de memoria compartida
 * (retorna NULL si error)
 */
void * preuser(int, int);

//Comprueba si se est intentando identificar un usuario, retorna
//NULL en caso de error o identificacin incorrecta
int startuser(char *);

//recoje el valor de una variable POST (introducida desde la interface web)
char * strget(char *, char *);

//Comprueba la correcta identificacin de un usuario
int identifica(char *);

//Hace desaparecer una memoria compartida en uso.
void delink(void *);

#endif
