/*
 *    AulaChat - Advanced teacher/pupil communication system
 *    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *    
 *    Modulo: Gestion web / Servicios web
 *
 */
 
#include "web.h"
#include "aulachat.h"
#include "user.h"
#include "msql.h"

//TODO: al hacer GET _comprobar_ que solo debe hacerse al index.html.
//TODO: Cerrar conexiones con la memoria compartida. -> Importante ya que Unix tiene un lmite pequeo.

int web(int *port, char *donde)
{
   //int port=84;
   //char *donde="/home/bluegod/aulachat/csl-aulachat/src/webroot";
   if(gosock(port))er("Error #1",NULL);
   if(superloop(donde))er("Error #2",NULL);
   return 0;
}


int gosock(int *port)
{
   struct sockaddr_in servidor;
   sck=socket(PF_INET,SOCK_STREAM,0);
   if(sck<0)return 1;
   //comunicacion TCP... esto suele ser siempre igual...
   //(escribimos info en la struct predeterminada de sockets)
   servidor.sin_family=AF_INET;
   servidor.sin_port=htons(*port);
   servidor.sin_addr.s_addr=htonl(INADDR_ANY);
   if(bind(sck, (struct sockaddr *) &servidor, sizeof(servidor)) < 0) return 1;
   //hasta aqui la creacin del socket.
   return 0;
}

int superloop(const char *que)  
{
   int vida=1,nclient;
   size_t tam,tam2;
   char buf[MAXBUFG]={'\0'};
   void *buff=NULL;
   struct sockaddr_in cliente;
   while(vida)
     {
	if(listen (sck, 1)<0)er("Error #3",NULL);
	tam=sizeof(cliente);
	nclient=accept(sck,(struct sockaddr *) &cliente, &tam);
	
	if(fork() !=0)
	  {
	     if(pide(&nclient,que,buf))er("Error #2-1",&nclient);
	     if(!(tam2=coje(buf))){
	        //Posible error 404, mandamos un 400 ms acorde ya que
		//en nuestro programa no deberan aparecer estos errores normalmente.
		s400(&nclient);
		//er("Error #2-2");
	     }
	     if(!(buff=calloc(1,tam2)))er("2-2-1",&nclient);; //no hay memoria...
	     if(coje2(buf,buff,&tam2))er("Error #2-3",&nclient);
	     if(da(&nclient,buff,buf,&tam2))er("Error #2-4",&nclient);
	     shutdown(nclient,SHUT_RDWR);
	     free(buff);
	     return 0;
	  }
     }
   return 0;
}
void s400(int *nclient)
{
   char *a="HTTP/1.0 400 OK\r\nServer: AulaChat/0.1\r\nConnection: close\r\nContent-Type: %s \r\n\r\n";
   char *b="<html><h2><font color=red>Peticin no vlida</font></h2><br><br>- AulaChat -</html>";
   write(*nclient,a,strlen(a));
   write(*nclient,b,strlen(b));
   er("Bad request",nclient);
}
void alarma(int sig)
{
   newac.sa_flags=SA_RESTART;
   //puts("alarma!");
}

int pide(int *csck, const char *donde, char *buf) //socket del cliente.
{
   //esta funcin intenta ser bastante eficiente.
   char *buf2= (char *) calloc(1,(MAXBUFG-strlen(donde))); //personalmente prefiero calloc frente a malloc al menos en strings.
   int j;
   //signal(SIGALRM,alarma);
   
   /* Problema con POST...
    * Al bloquearse la llamada a read, y mi no disposicin
    * a utilizar sockets no bloqueantes... lo he resuelto con 
    * "eventos?" xD Tras horas de bsqueda he encontrado algo factible:
    * "sigaction" He visto como implementaban otras cosas por ah en diversos
    * servidores web pero que no he llegado a entender, as que tras un par
    * de lecturas de manuales he encontrado que con esto parece que funciona. */
   
   newac.sa_handler=alarma;
   newac.sa_flags=0;
   sigemptyset(&(newac.sa_mask));
   sigaction(SIGALRM,&newac,NULL);
   alarm(ALARMA_TIME);//esperamos ALARMA_TIME segundos de bloqueo...
   
   while((j=read(*csck,buf2,(MAXBUFG-strlen(donde)-1)))>1);; 
   //si es un GET solo hace una, en un POST buscamos vars que interesen
   //asi que da igual que sobreescriba.
   // ! la web a redireccionar esta incluida en esas vars !
   //(mirar posibles errores al comprobar GETs falsos, etc!)
   
   alarm(0);
   //puts(buf2);
   if(!strstr(buf2,"x-www-form-urlencoded"))
     {
	sscanf(buf2,"GET %s",buf2);
	strncpy(buf,donde,400);// por seguridad.
	strcat(buf,buf2);
	//deberiamos tener en buf donde + buf2-get
	if(buf[strlen(buf)-1]=='/' && strlen(buf)<(MAXBUFG-25))strcat(buf,"index.html");
	//as es necesario poner / para indicar directorio.
	//if(DEBUG)syslog(0,buf);
	if(DEBUG)
	  { 
	     printf("GET: ");
	     puts(buf);
	  }
     }
   else 
     {
	//falta mirar si ya hay una /
	if(strstr(buf2,"&ok=Enviar")){
	   strcpy(buf,donde);
	   if(!startuser(buf2)) //identificado.
	     {
		aula *general=preuser(sizeof(aula),1);
		if(!strcmp(general->nombre,"ADMIN"))strcat(buf,"/admin.html");
		else strcat(buf,"/menu.html"); //else if.. bla bla bla
		delink(general);
	     }
	   else strcat(buf,"/noid.html");
	}
	else return 1;
     }
   return 0;
}
size_t coje(char *buf) 
{
   struct stat tam2;
   if(stat(buf, &tam2 ) != 0 )return 0; //al revs, esta func. da error si retorna 0
   return tam2.st_size;
}
int coje2(char *buf,void *buff,size_t *tam2)
{   
   int fich;
   fich=open(buf,O_RDONLY);
   if(read(fich, buff, *tam2)!=*tam2) return 1;
   close(fich);
   return 0;
}


int da(int *nclient,void *buff,char *buf,size_t *tam2)
{
   char cab[240]={'\0'};
   char *cab2="HTTP/1.0 200 OK\r\nServer: AulaChat/0.1\r\nConnection: close\r\nContent-Type: %s \r\n\r\n";
   char ext[15]={'\0'};
   int rt=0;
   if(fnmatch("*.jpg", basename(buf), 0)==0)strcpy(ext,"image/jpeg");
   else if(fnmatch("*.gif", basename(buf), 0)==0)strcpy(ext,"image/gif");
   else strcpy(ext,"text/html");
   //posiblemente ms opciones...
   
   sprintf(cab,cab2,ext);
   if(buff!=NULL)
     {
	aula *general=preuser(sizeof(aula),1);
	if(!(strcmp(general->nombre,"ADMIN")))rt=web_admin_global(buff,tam2);
	//else...
	delink(general);
	//mandamos cabecera:
	write(*nclient,cab,strlen(cab));
	//mandamos archivo:
	write(*nclient,buff,*tam2);
     }
   else puts("error de buff"); //error ? (el 404 no debe estar aki en principio...)
   return rt;
}
   
void er(const char *qpaso, int *nclient)
{
   //if(DEBUG)   syslog(0, qpaso);
   if(DEBUG) puts(qpaso);
   if(nclient!=NULL) shutdown(*nclient,SHUT_RDWR);
   exit(1);
   //salimos con salida de error y printamos mensaje en syslog.
}

int web_admin_global(void *buff,int *tam2)
{
   //se envia si es admin global
   char **que=NULL;
   char lista[300]={"\0"},add2[600]={"\0"}; //mas tarde cambiar por vars. en define
   char *query="SELECT profe from %s";
   char query2[100]={"\0"};
   sprintf(query2,query,NOMBREBD);
   int i=0;
   char *add="<br><form action=admin.html method=POST>Nuevo Profesor: <input type=text name=profe><br><br>"
     "<b>Lista de profesores:</b><br><br><font color=black> %s </font></form></span></body></html>";
   if((que=sqlquery(query2))==NULL){
      if(DEBUG)puts("Error #4-1"); //no usamos er() pq no conviene salir sin cerrar la conexion que si se cierra tras retornar
      return 1;
   }
   
   //copiamos resultados   
   while(que[i]!=NULL)
     {
	strcat(lista,que[i]);
	strcat(lista,"<br>");
	i++;
     }
   sprintf(add2,add,lista);
   size_t tam;
   tam=strlen(add2);
   *tam2+=tam;
   if((buff=realloc(buff,*tam2))==NULL)return 1; //pedimos ms memoria.
   strcat(buff,add2);
   return 0;
}
